<?
// ---------------------------------------------------------------
// PHPnetemGUI
//
// Copyright 2005 British Telecommunications plc
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc.
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------

//********************************************************************************
//Function to change the default selected value in a selectbox if it doesn't match
//$value
//(Currently not in use)
//********************************************************************************
function default_select_option($selectHTML, $value) {

	//Check the current selected value for a match against $value
	//Set $n to the position of the first character of the default selected value
	//This is 9 characters after the start of the word, "selected"
	$n=(strpos($selectHTML, "selected") + 9);
	$tmpStr="";

	//While $n is not a '<' character
	while(ord(substr($selectHTML, $n, 1))!=60):
		//Add character to $tempStr
		$tmpStr=$tmpStr . substr($selectHTML, $n, 1);
		//Increment $n
		$n = ++$n;
	endwhile;

	//If $tmpStr doesn't match $value then:
	//Replace "selected" in the $selectHTML with ""
	//Find the position of the correct matching value and set $n to one space before it
	//Insert " selected" one space before the matching value
	if ($tmpStr!=$value) {
		$selectHTML=str_replace("selected", "", $selectHTML);
		$n=(strpos($selectHTML, $value)-1);
		$selectHTML=substr_replace($selectHTML, " selected ", $n, 0);
	}
}

