<?
// ---------------------------------------------------------------
// PHPnetemGUI
//
// Copyright 2005 British Telecommunications plc
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc.
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------

//******************************
//Function to display interfaces
//******************************
function show_interfaces ($interfaces, $del, $delJitter, $delCorrelation, $delDistribution, $loss, $lossCorrelation, $dup, $dupCorrelation, $reorder, $reorderCorrelation, $gap, $bandwidth, $limit, $displayCmd, $src, $srcSub, $dest, $destSub, $advanced, $showButton) {

	//Set showButton to false
	$showButton=false;

	//Display the commands if the 'Display commands' checkbox was checked.
	if (isset($_POST['chkDisplay']) & isset($_POST['btnRefresh'])==false & isset($_POST['btnReset'])==false & $displayCmd!="") {
?>
		<div style="color: #000000; background-color: #ffffff; border: thin solid #000000; width: 970; align: center;">
			<p align="center"><b>The following commands would be executed:</b></p>
			<p><?=$displayCmd?></p>
		</div>
<?
	}
	for ($i=1; $i<=count($interfaces);++$i) {
		if ($advanced[$i-1]!=1) {
		    //There is an interface with none or one rule set so the apply settings button should be set
		    //to visible
			$showButton=true;
?>
	<div style="color: #000000; background-color: #aaccff; border: thin solid #000000; width: 970; height: 235; align: center">
		<table border="1" width="100%" height="82">
		  <tr>
			<td width="100%" colspan="10" height="13" align="center">
			  <p align="center"><b>Interface: <?=$interfaces[$i-1]?></b>
			</td>
		  </tr>
		  <tr>
			<td width="100%" colspan="10" height="13" align="center">Limit(Packets) <input type="text" name="txtLimit<?=$i?>" size="9" value=<? echo $limit[$i-1] ?>>
			Default=1000
			</td>
		  </tr>
			<td width="20%" colspan="2" height="19">
			  <p align="center"><b>Delay</b></td>
			<td width="20%" colspan="2" height="19">
			  <p align="center"><b>Loss</b></td>
			<td width="20%" colspan="2" height="19">
			  <p align="center"><b>Duplication</b></p></td>
			<td width="20%" colspan="2" height="19">
			  <p align="center"><b>Packet reordering</b></td>
			<td width="20%" colspan="2" height="19">
			  <p align="center"><b>Bandwidth</b></td>
		  </tr>
		  <tr>
			<td width="11%" height="23">Delay time(ms) </td>
			<td width="9%" height="23"><input type="text" name="txtDelay<?=$i?>" size="9" value=<? echo $del[$i-1] ?>></td>
			<td width="11%" height="23">Loss(%)</td>
			<td width="9%" height="23"><input type="text" name="txtLoss<?=$i?>" size="9" value=<? echo $loss[$i-1] ?>></td>
			<td width="11%" height="23">Duplication(%)</td>
			<td width="9%" height="23"><input type="text" name="txtDup<?=$i?>" size="9" value=<? echo $dup[$i-1] ?>></td>
			<td width="9%" height="23">Reordering(%)</td>
			<td width="9%" height="23"><input type="text" name="txtReorder<?=$i?>" size="9" value=<? echo $reorder[$i-1] ?>></td>
			<td width="13%" height="23">Bandwidth(Kb/s)</td>
			<td width="9%" height="23"><input type="text" name="txtBandwidth<?=$i?>" size="10" value=<? echo $bandwidth[$i-1] ?>></td>
		  </tr>
		  <tr>
			<td width="11%" height="1">Jitter(ms)</td>
			<td width="9%" height="1"><input type="text" name="txtDelayJitter<?=$i?>" size="9" value=<? echo $delJitter[$i-1] ?>></td>
			<td width="11%" height="1">Correlation(%)</td>
			<td width="9%" height="1"><input type="text" name="txtLossCorrelation<?=$i?>" size="9" value=<? echo $lossCorrelation[$i-1] ?>></td>
			<td width="11%" height="1">Correlation(%)</td>
			<td width="9%" height="1"><input type="text" name="txtDupCorrelation<?=$i?>" size="9" value=<? echo $dupCorrelation[$i-1] ?>></td>
			<td width="11%" height="3">Correlation(%)</td>
			<td width="9%" height="3"><input type="text" name="txtReorderCorrelation<?=$i?>" size="9" value=<? echo $reorderCorrelation[$i-1] ?>></td>
		  </tr>
		  <tr>
			<td width="11%" height="27">Correlation(%)</td>
			<td width="9%" height="27"><input type="text" name="txtDelayCorrelation<?=$i?>" size="9" value=<? echo $delCorrelation[$i-1] ?>></td>
			<td width="11%" height="27"></td>
			<td width="9%" height="27"></td>
			<td width="11%" height="27"></td>
			<td width="9%" height="27"></td>
			<td width="11%" height="27">Gap(packets)</td>
			<td width="9%" height="27"><input type="text" name="txtGap<?=$i?>" size="9" value=<? echo $gap[$i-1] ?>></td>
		  </tr>
		  <tr>
			<td width="11%" height="28">Distribution</td>
			<td width="9%" height="28"><select size="1" name="selDelayDistribution<?=$i?>">
			  <option <?if($delDistribution=="0") echo "selected"?>>-N/A-</option>
			  <option>Normal</option>
			  <option>Pareto</option>
			  <option>Paretonormal</option>
			  </select></td>
		  </tr>

		  <tr>
			<td width="100%" colspan="10">
				<table border="1" width="100%">
				  <tr>
					<td width="9%" height="23">IP source addr</td>
					<td width="11%" height="23"><input type="text" name="txtSrc<?=$i?>" size="13" value=<? echo $src[$i-1] ?>></td>
					<td width="10%" height="23">Ip source subnet</td>
					<td width="11%" height="23"><input type="text" name="txtSrcSub<?=$i?>" size="13" value=<? echo $srcSub[$i-1] ?>></td>
					<td width="13%" height="23">IP destination addr</td>
					<td width="11%" height="23"><input type="text" name="txtDest<?=$i?>" size="13" value=<? echo $dest[$i-1] ?>></td>
					<td width="13%" height="23">IP destination subnet</td>
					<td width="11%" height="23"><input type="text" name="txtDestSub<?=$i?>" size="13" value=<? echo $destSub[$i-1] ?>></td>
				  </tr>
				</table>
			</td>
		  </tr>
		</table>
	  </div>
<?
		} else {
			//Display the advanced mode warning in the interface box instead of all the expected fields
?>
		<div style="color: #000000; background-color: #aaccff; border: thin solid #000000; width: 970; height: 140; align: center">
		<table border="1" width="100%" height="15">
		  <tr>
			<td width="100%" colspan="10" height="13" align="center">
			  <p align="center"><b>Interface: <?=$interfaces[$i-1]?></b>
			</td>
		  </tr>
		</table>
		<p align="center"><b>There is more than one set of netem rules running on this interface. Use advanced mode to edit these rules or delete them with the "reset settings" button.</b></p>
		</div>
<?
		}
	}
}
?>
